BFB goext library
=================

A collection of general & useful library methods

This should not have any heavy dependencies (gin, mongo, etc) and add missing basic language features...

Potentially needs `export GOPRIVATE="gogs.mikescher.com"`


### Packages:

| Name         | Maintainer | Description                                                                                                   |
|--------------|------------|---------------------------------------------------------------------------------------------------------------|
| langext      | Mike       | General uttility/helper functions, (everything thats missing from go standard library)                        |
| mathext      | Mike       | Utility/Helper functions for math                                                                             |
| cryptext     | Mike       | Utility/Helper functions for encryption                                                                       |
| syncext      | Mike       | Utility/Helper funtions for multi-threading / mutex / channels                                                |
| dataext      | Mike       | Various useful data structures                                                                                |
| zipext       | Mike       | Utility for zip/gzip/tar etc                                                                                  |
| reflectext   | Mike       | Utility for golagn reflection                                                                                 |
|              |            |                                                                                                               |
| mongoext     | Mike       | Utility/Helper functions for mongodb                                                                          |
| cursortoken  | Mike       | MongoDB cursortoken implementation                                                                            |
|              |            |                                                                                                               |
| totpext      | Mike       | Implementation of TOTP (2-Factor-Auth)                                                                        |
| termext      | Mike       | Utilities for terminals (mostly color output)                                                                 |
| confext      | Mike       | Parses environment configuration into structs                                                                 |
| cmdext       | Mike       | Runner for external commands/processes                                                                        |
|              |            |                                                                                                               |
| sq           | Mike       | Utility functions for sql based databases                                                                     |
| tst          | Mike       | Utility functions for unit tests                                                                              |
|              |            |                                                                                                               |
| rfctime      | Mike       | Classes for time seriallization, with different marshallign method for mongo and json                         |
| gojson       | Mike       | Same interface for marshalling/unmarshalling as go/json, except with proper serialization of null arrays/maps |
|              |            |                                                                                                               |
| bfcodegen    | Mike       | Various codegen tools (run via go generate)                                                                   |
|              |            |                                                                                                               |
| rext         | Mike       | Regex Wrapper, wraps regexp with a better interface                                                           |
| wmo          | Mike       | Mongo Wrapper, wraps mongodb with a better interface                                                          |
|              |            |                                                                                                               |